CUDA_ID=$1
export CUDA_VISIBLE_DEVICES=$CUDA_ID

TASK=$2
MODEL_PATH=$3
CORPUS_PATH=$4
NUM_GEN=$5
SEED=$6

case $TASK in
    cola)
        LABELS=("0")
        EXTRA="--temperature 5"
        ;;
    sst-2)
        LABELS=("0")
        EXTRA="--temperature 0.3"
        ;;
    mrpc)
        LABELS=("0" "1")
        ;;
    qqp)
        LABELS=("0" "1")
        ;;
    mnli)
        LABELS=("entailment" "neutral" "contradiction")
        ;;
    qnli)
        LABELS=("entailment" "not_entailment")
        ;;
    rte)
        LABELS=("not_entailment" "entailment")
        ;;
esac

for LABEL in "${LABELS[@]}"
do
    python gen.py --model_name_or_path "${MODEL_PATH}" \
                    --save_dir "gen_res_${TASK}_${SEED}" \
                    --label $LABEL \
                    --temperature 0 \
                    --p 1.0 \
                    --k 15 \
                    --num_gen $NUM_GEN \
                    --max_len 50 \
                    --print_res \
                    --pretrain_corpus_dir $CORPUS_PATH \
                    --task $TASK \
                    $EXTRA
done
